#include <htc.h>
char dcf();
char paritycheck(char, char, char, char);
char man();
char wecker();
char swap(char);
void pwm_init();
void pwm_sekunden(char);
void pwm_minuten(char);
void pwm_stunden(char);

//PWM Festwerte
float sec = 0.083;				//Spannungswert fr eine Sekunde/Minute/Stunde
unsigned char voltage = 5;		//Maximal auszugebende Spannung (Spter fr die Umrechnung notwendig!)
float TOSC = 1/8000000;			//Oszillatorfrequenz

#define S1 RA0
#define S2 RA1
#define S3 RA2
/*___________________________________________________________________________________________________________________________________________________________________________*/
//Anfang der Mainfunktion
void main(void){
OSCCON = 0x72;
#ifndef _XTAL_FREQ				//Deklaration der Prozessorfrequenz zur genauen Kalibrierung der __delay_ms(); Funktion
#define _XTAL_FREQ 8000000
#endif
char key_pressed = 0;			//Zhler fr gedrckte Tasten
int T_count = 0;					//Zhler fr die wartezeit der Tasterabfrage
char zero = 1;					//Verrigelungsvariabel fr die Schalter
int count2 = 0;
unsigned char sync = 0;
TRISA = 0xFF;
TRISD = 0x02;
pwm_init();

//Schalterabfrage
while (1){
if (S3 == 1 && zero == 1){
	__delay_ms(1);
	count2++;
	if (count2 >= 3000){
	sync = 0;
	key_pressed++;
	zero = 0;
}	
if (S3 == 0 && zero == 0){
	zero = 1;
}	

//Wartefunktion fr die Taster
if (key_pressed > 1){
	__delay_ms(1);
	T_count++;

	//Manuelle Zeiteingabe
	if (key_pressed == 2 && T_count >= 1450){
		key_pressed = 0;
		sync = 1;	
		man();
	}
	//Wecker
	if (key_pressed == 3 && T_count >= 1450){
		key_pressed = 0;
		wecker();
	
	}

//Reset der Wartezeit
	if (T_count > 1500)
		T_count = 0;
	}	
}
}//Ende Main


/*___________________________________________________________________________________________________________________________________________________________________________*/
//DCF Zeitsignal Empfangen
char dcf(){
//	unsigned char count = 0;				//Sekundenzhler
	unsigned int count_new = 0;				//Minutenbeginn
	unsigned char time = 0;					//Zeit der Amplitudenabsenkung
	char value = 0;							//Aktueller Wert der Modulation
	unsigned char minuten_einer = 0;		//Minutenveriabel einer
	unsigned char minuten_zehner = 0;		//Minutenveriabel zehner
	unsigned char stunden_einer = 0;		//Stundenvariabel einer
	unsigned char stunden_zehner = 0;		//Stundenvariabel zehner
	unsigned char geradeM = 0;				//Parittsbit fr Minuten
	unsigned char geradeS = 0;				//parittsbit fr Stunden
	unsigned char schleife = 255;			//Zhler fr Schleifendurchlufe
	unsigned char new = 0;					//Anzeige fr neue Minutenmarke
	unsigned char minuten = 0;				//Empfangene Minutenanzahl
	unsigned char stunden = 0;				//Empfangene Stundenanzahl
	unsigned char p_minuten = 0;			//Parittsbesttigung fr Minuten
	unsigned char p_stunden = 0;			//Parittsbesttigung fr Stunden

while(1){
while(1){
	count_new = 0;
	//Neue Minutenmarke erkennen
	if (RD1 == 0){
		while(RD1 = 0){
			__delay_ms(1);
			count_new++;
		}
	}	
	//Sekunde erkennen
	if (RD1 == 1){
		count++;
		while(RD1 = 1){
			__delay_ms(1);
			time++;
		}
	}
//Beginn einer neuen Minutenmarke erkennen
if (count_new >= 900 && count_new <= 1100){
	count = 0;
	new = 1;
}

//Modulierte 0 erkennen
if (time >= 75 && time <= 125){
	value = 0;
}

//Modulierte 1 erkennen
if (time >= 175 && time <= 225){
	value = 1;
}

//Schleife darf nur einmal pro Sekunde durchlaufen!!!
if (schleife != count){
//Minuten Einer Bit's erfassen
if (count >= 21 && count <= 24){
	minuten_einer = value;
	minuten_einer = minuten_einer << 1;
//Variabel fr den Swap vorbereiten	
	if (count == 24){
		minuten_einer = minuten_einer << 4;
}
}

//Minuten Zehner Bit's erfassen
if (count >= 25 && count <= 27){
	minuten_zehner += value;
	minuten_zehner = minuten_zehner << 1;
//Variabel fr den Swap vorbereiten
	if (count == 27){
		minuten_zehner = minuten_zehner << 5; 
}
}

//Parittsbit fr Minuten
if (count == 28 && value == 1){
	geradeM = 1;
}

//Stunden Einer Bit's erfassen
if (count >= 29 && count <= 32){
	stunden_einer = value;
	stunden_einer = stunden_einer << 1;
//Variabel fr den Swap vorbereiten
	if (count == 32){
		stunden_einer = stunden_einer << 5; 
}
}

//Stunden Zehner Bit's erfassen
if (count >= 33 && count <= 34){
	stunden_zehner += value;
	stunden_zehner = stunden_zehner << 1;
//Variabel fr den Swap vorbereiten
	if (count == 34){
		stunden_zehner = stunden_zehner << 5; 
}
}
//Parittsbit fr Stunden
	if (count == 35 && value == 1){
		geradeS = 1;
	}

schleife = count; //Schleife auf den Wert des Sekundenzhlers setzen

}

/*Wird eine neue Minutenmarke erkannt, wird der Schleifendurchlauf unterbrochen und berprft ob alle notwendigen Bit's empfangen wurden
und die bertragung fehlerfrei verlief*/
	if ( new == 1){

	}	
}

p_minuten = paritycheck(geradeM, minuten_zehner, minuten_einer, 4);		//Parittscheck der Minuten
p_stunden = paritycheck(geradeS, stunden_zehner, stunden_einer, 2);		//Parittscheck der Stunden

swap(minuten_einer);													//Minutenbits einer umdrehen
swap(minuten_zehner);													//Minutenbits zehner umdrehen

swap(stunden_einer);													//Stundenbits einer umdrehen									
swap(stunden_zehner);													//Stundenbits zehner umdrehen

minuten = (minuten_zehner * 10) + minuten_einer;						//Minuten zusammenfassen
stunden = (stunden_zehner * 10) + stunden_einer;						//Stunden zusammenfassen 
}

}

/*___________________________________________________________________________________________________________________________________________________________________________*/
//Paritycheck
char paritycheck(char gerade, char zehner, char einer, char push){

	char parcount = 0;		//Maximale Anzahl Schleifendurchlufe bis Epic Fail
	char par = 0;			//Variabel die Anzeigt ob die Paritt gegeben ist. Bei Erfolg wird 42 (Die Antwort auf alles in der Welt) an die aufrufende Funktion zurckgegeben
	char wert = 0;			//Chachwert des Paritychecks

//Werte zusammenfassen
	wert = zehner;
	wert = wert << push;
	wert += einer;

	wert = wert << 1;
	wert += gerade;
	
//Paritt ermitteln
	wert = (wert >> 4) ^ (wert & 0x0F);
	wert = (wert >> 2) ^ (wert & 0x03);
	wert = (wert >> 1) ^ (wert & 0x01);

	if (wert == 0){
		par = 42;	//Erfolgreiche Parittsprfung
	}	
return (par);
}

/*___________________________________________________________________________________________________________________________________________________________________________*/
//Bits in die richtige Reihenfolge bringen
char swap(char string){
	char mask = 0x01;
	char copy = 0;
	char back = 0;
//1. Bit swappen
	copy = string;
	copy &= mask;
	back = copy;
	back = back << 1;
//2.-8. Bit swappen
	for (int i = 0; i != 7; i++){
	copy = string;
	copy = copy >> 1;
	copy &= mask;
	back += copy;
	back = back << 1;
	}
return (back);
}
/*___________________________________________________________________________________________________________________________________________________________________________*/
//Pulsweitenmodulation
//Sekundenmodulation
void pwm_sekunden(char zeit){	
	float load = 0;
	char load1 = 0;
	//Formel fr die Umrechnung
	load = (zeit*sec)/voltage;
	load = TOSC*load;
	load = load/(TOSC*16);
	load1 = load;
	//PWM Register 1 laden
	CCPR1L = load;
}
//Minutenmodulation
void pwm_minuten(char zeit){	
	float load = 0;
	char load1 = 0;
	//Formel fr die Umrechnung	
	load = (zeit*sec)/voltage;
	load = TOSC*load;
	load = load/(TOSC*16);
	load1 = load;
	//PWM Register 2 laden
	CCPR2L = load;
}
//Stundenmodulation
void pwm_stunden(char zeit){	
	float load = 0;
	char load1 = 0;
	//Formel fr die Umrechnung
	load = (zeit*sec)/voltage;
	load = TOSC*load;
	load = load/(TOSC*16);
	load1 = load;
	//PWM Register 3 laden
	CCPR3L = load;
}
/*___________________________________________________________________________________________________________________________________________________________________________*/
//Initialisierung der PWM Kanle
void pwm_init(){
	TRISC =	  0x02;
	CCP1CON = 0x0C;
	CCP2CON = 0x0C;
	CCP3CON = 0x0C;
	T2CON =   0x06;
	PR2 =  	  12;
}
/*___________________________________________________________________________________________________________________________________________________________________________*/
//Weckerfunktion
char wecker(){
	unsigned char weckzeit_minuten = 0;
	unsigned char weckzeit_stunden = 0;
	unsigned char zero1 = 1;	
	unsigned char zero2 = 0;
//Schalterabfrage
while(S3 != 1){
	
	if (S1 == 1 && zero1 == 1){
		weckzeit_stunden++;
		zero1 = 0;
}	
	if (S1 == 0 && zero1 == 0){
		zero1 = 1;
}
	if (S2 == 1 && zero2 == 1){
		weckzeit_minuten++;
		zero2 = 0;
}	
	if (S2 == 0 && zero2 == 0){
		zero2 = 1;
}	
//Ausgeben der aktuell eingestellten Weckzeit an den Messgerten
	pwm_minuten(weckzeit_minuten);	
	pwm_Stunden(weckzeit_stunden);
}
return (weckzeit_stunden, weckzeit_minuten);
}
/*___________________________________________________________________________________________________________________________________________________________________________*/
//Funktion fr Manuelle Zeiteingabe
char man(){
	unsigned char uhrzeit_minuten = 0;
	unsigned char uhrzeit_stunden = 0;
	unsigned char zero1 = 1;	
	unsigned char zero2 = 0;
//Schalterabfrage
while(S3 != 1){
	
	if (S1 == 1 && zero1 == 1){
		uhrzeit_stunden++;
		zero1 = 0;
}	
	if (S1 == 0 && zero1 == 0){
		zero1 = 1;
}
	if (S2 == 1 && zero2 == 1){
		uhrzeit_minuten++;
		zero2 = 0;
}	
	if (S2 == 0 && zero2 == 0){
		zero2 = 1;
}	
//Ausgeben der aktuell eingestellten Uhrzeit an den Messgerten
	pwm_minuten(uhrzeit_minuten);	
	pwm_Stunden(uhrzeit_stunden);
}
return (uhrzeit_stunden, uhrzeit_minuten);
}
